"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var InputChildrenInternal = /** @class */ (function (_super) {
    __extends(InputChildrenInternal, _super);
    function InputChildrenInternal() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = { width: 1, height: 1 };
        return _this;
    }
    InputChildrenInternal.prototype.componentDidMount = function () {
        this.computeChildrenSize();
    };
    InputChildrenInternal.prototype.computeChildrenSize = function () {
        var _a = this.childrenWrapper, clientWidth = _a.clientWidth, clientHeight = _a.clientHeight;
        if (
        // Instead of plain !== comparison, using a magic number
        // to defend against possible rounding errors in
        // `clientHeight`/`clientWidth`, and avoid causing re-render loops.
        // See https://github.com/buildo/react-input-children/issues/47
        Math.abs(clientWidth - this.state.width) > 1 ||
            Math.abs(clientHeight - this.state.height) > 1) {
            this.setState({
                height: clientHeight,
                width: clientWidth
            });
        }
    };
    InputChildrenInternal.prototype.getInputStyle = function () {
        return __assign(__assign({}, this.props.style), { paddingRight: this.state.width, width: '100%', boxSizing: 'border-box' });
    };
    InputChildrenInternal.prototype.getChildrenStyle = function () {
        return {
            position: 'absolute',
            top: '50%',
            right: 0,
            marginTop: -1 * (this.state.height / 2)
        };
    };
    InputChildrenInternal.prototype.render = function () {
        var _this = this;
        var _a = this.props, children = _a.children, _b = _a.wrapper, wrapper = _b === void 0 ? {} : _b, inputRef = _a.inputRef, inputProps = __rest(_a, ["children", "wrapper", "inputRef"]);
        var wrapperProps = __assign(__assign({}, wrapper), { style: __assign(__assign({}, wrapper.style), { position: 'relative' }) });
        return (React.createElement("div", __assign({}, wrapperProps),
            React.createElement("input", __assign({}, inputProps, { style: this.getInputStyle(), ref: inputRef })),
            React.createElement("div", { ref: function (ref) { return _this.childrenWrapper = ref; }, style: this.getChildrenStyle() }, children)));
    };
    InputChildrenInternal.prototype.componentDidUpdate = function () {
        this.computeChildrenSize();
    };
    return InputChildrenInternal;
}(React.Component));
/**
 * `InputChildren` is a replacement for the base input react component capable of rendering
 * a child (link, button...) inside the input itself. It supports the same props of react input.
 */
exports.InputChildren = React.forwardRef(function (props, ref) { return React.createElement(InputChildrenInternal, __assign({}, props, { inputRef: ref })); });
